<?php
require_once('SimplePieAutoloader.php');
class Plugin_simplepie extends Plugin {

  var $meta = array(
  'name'       => 'Simple Pie',
  'version'    => '0.9',
  'author'     => 'Mubashar Iqbal',
  'author_url' => 'http://muabshariqbal.com'
  );

  public function feed() {
    $url            = $this->fetch_param('url', null);
    $orderbydate    = $this->fetch_param('orderbydate', false, false, true); // defaults to no
    $count          = $this->fetch_param('count', 10);

    $feed = new SimplePie();

    $feed->set_cache_location("_cache");
    // to enable the cache create a cache folder in the root of the site and comment out the line below
    //$feed->enable_cache(false);

    $feed->set_feed_url($url);
    $feed->enable_order_by_date($orderbydate);

    $success = $feed->init();
    $feed->handle_content_type();
    if ($feed->error()) {
    } else {
      if ($success) {
        $loop_count = 0;
        $output = "";
        $parser = new Lex_Parser();
        $parser->scope_glue(':');
        $parser->cumulative_noparse(true);

        foreach($feed->get_items() as $item) {
          $arr = array();
          $arr['permalink'] = $item->get_permalink();
          $arr['title'] = $item->get_title();
          $arr['date'] = $item->get_date("Y-m-d");
          $loop_count ++;
          $output .= $parser->parse($this->content, $arr);
          if ($loop_count >= $count) {
            break;
          }
        }
        return $output;
      }
    }
    return '';
  }

}