<?php
class Statamic_Auth {


  // STATIC FUNCTIONS
  // ------------------------------------------------------
  public static function login($username, $password, $remember=false) {

    $u = self::get_user($username);
    if ($u && $u->correct_password($password)) {
      $app = Slim::getInstance();
      $app->setEncryptedCookie('stat_auth_cookie', $username.":".md5($u->get_encrypted_password().$app->config['_cookies.secret_key']));
      return true;
    } else {
      return false;
    }

  }

  public static function logout() {
    $app = Slim::getInstance();
    $cookie = $app->deleteCookie('stat_auth_cookie');
  }

  public static function user_exists($username) {
    return !(self::get_user($username) == null);
  }

  public static function is_logged_in() {
    $user = null;

    $app = Slim::getInstance();
    $cookie = $app->getEncryptedCookie('stat_auth_cookie');

    if ($cookie) {
      list($username,$hash) = explode(":", $cookie);
      $user = self::get_user($username);

      // TODO: VALIDATE THE USER WITH THE COOKIE INFO
      $app->setEncryptedCookie('stat_auth_cookie', $cookie);

      return $user;
    } else {
      return false;
    }
  }

  public static function get_user($username) {
    $u = Statamic_User::load($username);
    return $u;
  }

  public static function get_current_user() {
    $u = self::is_logged_in();
    return $u;
  }

  public static function get_user_list() {
    $users = array();
    $folder = "_config/users/*.yaml";
    $list = glob($folder);
    foreach ($list as $name) {
      $start = strrpos($name, "/")+1;
      $end = strrpos($name, ".");
      $users[substr($name, $start, $end-$start)] = self::get_user(substr($name, $start, $end-$start));
    }
    return $users;
  }

}