<?php
class Plugin_taxonomy extends Plugin {


  public function listing() {
    $app = Slim::getInstance();

    $folder      = $this->fetch_param('folder', null); // defaults to null
    $type        = $this->fetch_param('type', null); // defaults to null
    $limit       = $this->fetch_param('limit', null, 'is_numeric'); // defaults to none
    $sort_by     = $this->fetch_param('sort_by', 'name'); // defaults to name
    $min_count   = $this->fetch_param('min_count', 1, 'is_numeric'); // defaults to 1

    if ($folder == null) {
      $folder = ltrim($this->fetch_param('from', $app->request()->getResourceUri()), "/");
    }

    if ($folder && $type) {
      $list = Statamic::get_content_list($folder, null, null, false, true, null, null, '');

      $counts = array();
      $urls   = array();
      foreach ($list as $item) {
        if (isset($item[$type])) {
          foreach ($item[$type] as $key => $value) {
            if (isset($counts[$value['name']])) {
              $counts[$value['name']] += 1; 
            } else {
              $counts[$value['name']] = 1; 
            }

            if (isset($urls[$value['name']])) {
            } else {
              $urls[$value['name']] = $value['url']; 
            }
          }
        }
      }

      if ($sort_by == 'count') {
        asort($counts, SORT_STRING);
        $counts = array_reverse($counts);
      } else {
        ksort($counts, SORT_STRING);
      }

      $data = array();
      foreach ($counts as $key => $value) {
        if ($value >= $min_count) {
          $arr = array(
            'name' => $key
          , 'count' => $value
          , 'url' => $urls[$key]
          );
          $data[] = $arr;
        }
      }

      if ($limit) {
        $data = array_splice($data, 0, $limit);
      }
      if (sizeof($data)) {
        return $this->parse_loop($this->content, $data);
      } else {
        $arr = array();
        $arr['no_results'] = true;
        return $arr;
      }
    }
    return array();
  }

}