<?php
class Fieldtype {

  public static function render_fieldtype($fieldtype, $fieldname, $field_config, $field_data) {

    $output = '';

    $fieldtype_folders = array('add-ons/', 'admin/fieldtypes/');
    
    foreach ($fieldtype_folders as $folder) {
      if (is_dir($folder.$fieldtype) && is_file($folder.$fieldtype.'/ft.'.$fieldtype.'.php')) {
      
        $file = $folder.$fieldtype.'/ft.'.$fieldtype.'.php';
        break;
      
      } elseif (is_file($folder.'/ft.'.$fieldtype.'.php')) {
      
        $file = $folder.'/ft.'.$fieldtype.'.php';
        break;
      }
    }

    # fieldtype exists
    if (isset($file)) {

      require_once($file);
      $class = 'Fieldtype_'.$fieldtype;

      #formatted properly
      if (class_exists($class)) {
        $field = new $class();
      }

      # function exists
      if (method_exists($field, 'render')) {
        $field->field_config = $field_config;
        $field->fieldname    = "page[yaml][$fieldname]";
        $field->field_data   = $field_data;
        
        $output = $field->render();
      }
        
    }
    
    return $output;
  }

  public static function process_field_data($fieldtype, $field_data) {

    $fieldtype_folders = array('add-ons/', 'admin/fieldtypes/');
    
    foreach ($fieldtype_folders as $folder) {
      if (is_dir($folder.$fieldtype) && is_file($folder.$fieldtype.'/ft.'.$fieldtype.'.php')) {
      
        $file = $folder.$fieldtype.'/ft.'.$fieldtype.'.php';
        break;
      
      } elseif (is_file($folder.'/ft.'.$fieldtype.'.php')) {
      
        $file = $folder.'/ft.'.$fieldtype.'.php';
        break;
      }
    }

    # fieldtype exists
    if (isset($file)) {

      require_once($file);
      $class = 'Fieldtype_'.$fieldtype;

      #formatted properly
      if (class_exists($class)) {
        $field = new $class();
      }

      # function exists
      if (method_exists($field, 'process')) {
        $field->field_data   = $field_data;
        $field_data = $field->process();
      }
        
    }

    return $field_data;
  }

}