<?php
/**
 * Statamic
 * 
 * Statamic is a light-weight and flexible, file-based publishing engine.
 * Kudos to Slim (slimframework.com) for powering the RESTful routing
 *
 * @author Jack McDade (jack@statamic.com)
 * @author Mubasher Iqbal (mubs@statamic.com)
 * @copyright 2012 Lobster War Machine
 */

// Load app
require '_app/slim/Slim.php';
require '_app/statamic/helper.php';
require '_app/statamic/plugin.php';
require '_app/statamic/statamic.php';
require '_app/statamic/view.php';
require '_app/libraries/Lex/Autoloader.php';
require '_app/libraries/markdown.php';
require '_app/libraries/classTextile.php';
require '_app/libraries/spyc.php';


// Config Initialization
$config = Statamic::load_all_configs();
$config['theme_path'] = '_themes/'.$config['_theme']."/";
$config['templates.path'] = './_themes/'.$config['_theme']."/";
$config['debug'] = $config['_debug'];

// Slim initialization
$app_view = new Statamic_View();
$config['view'] = $app_view;
$app = new Slim(
  $config
);
// Sitewide global config
$app->config = $config;

Statamic_View::set_layout("layouts/default");

require '_app/_routes.php';

$app->run(); # Go forth!
